(in-package #:cl-user)

(load "load-stumpwm.lisp")

(stumpwm:set-module-dir "/usr/local/share/stumpwm")

(when (uiop:version<= "3.1.5" (asdf:asdf-version))
  ;; We register StumpWM and its dependencies as immutable, to stop ASDF from
  ;; looking for their source code when loading modules.
  (uiop:symbol-call '#:asdf '#:register-immutable-system :stumpwm)
  (dolist (system-name (uiop:symbol-call '#:asdf '#:system-depends-on (asdf:find-system :stumpwm)))
    (uiop:symbol-call '#:asdf '#:register-immutable-system system-name)))

(sb-ext:save-lisp-and-die "stumpwm" :toplevel (lambda ()
                                                ;; asdf requires sbcl_home to be set, so set it to the value when the image was built
                                                (alexandria:when-let ((home #.(sb-ext:posix-getenv "SBCL_HOME")))
                                                  (sb-posix:putenv (format nil "SBCL_HOME=~A" home)))
                                                (stumpwm:stumpwm)
                                                0)
                                    :executable t
                                    :purify t
                                    :compression (if (member :sb-core-compression *features*) @COMPRESSION@ nil))
